{% extends "plantilla.html"%}
{% block contenido%}
{% load static %}

<div class="intro-section single-cover" id="home-section">

      <div class="slide-1" style="background-image: url('{{ imagen_url }}');" data-stellar-background-ratio="0.5">
        <div class="container">
          <div class="row align-items-center">
            <div class="col-12">
              <div class="row justify-content-center align-items-center text-center">
                <div class="col-lg-6">
                  <h1 data-aos="fade-up" data-aos-delay="0">Asignatura</h1>
                  <!-- <div class="col-lg-8 ml-auto" data-aos="fade-up" data-aos-delay="500"> -->
                  <!-- Button trigger modal -->
                  <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal">
                    Agregar Asignatura
                  </button>
                  <!-- </div> -->
                </div>

              </div>
            </div>

          </div>
        </div>
      </div>
    </div>


    <div class="site-section">
      <div class="container">
        <h2>Listado de Asignaturas</h2>
        <div class="row">
          <div class="col-md-12" >


            <table class="table" id="tbl" >
              <thead>
                <tr>
                  <th>ID</th>
                  <th>Nombre</th>
                  <th>Creditos</th>
                  <th>Fecha inicio</th>
                  <th>Fecha Final</th>
                  <th>Profesor</th>
                  <th>Silabo</th>
                  <th>Semestres</th>
                  <th>Descripción</th>
                  <th>Curso</th>
                  <th>Acciones</th>

                </tr>
              </thead>
              <tbody>
                {% for asignatura in asignaturas %}
                  <tr>
                    <td>{{ asignatura.idAsignaturadcp }}</td>
                    <td>{{ asignatura.nombreAsignaturadcp }}</td>
                    <td>{{ asignatura.creditosAsignaturadcp }}</td>
                    <td>{{ asignatura.fecha_inicioAsignaturadcp }}</td>
                    <td>{{ asignatura.fecha_finalAsignaturadcp }}</td>
                    <td>{{ asignatura.profesorAsignaturadcp }}</td>
                    <td>
                      <a href="{{ asignatura.silaboAsignaturadcp.url }}" download="nombre_del_archivo.pdf">Descargar Silabo</a>
                    </td>
                    <td>{{ asignatura.semestreAsignaturadcp }}</td>
                    <td>{{ asignatura.descripcionAsignaturadcp }}</td>
                    <td>{{ asignatura.curso.nivelCursodcp }}</td>
                    <td>
                      <a href="/editarAsignatura/{{asignatura.idAsignaturadcp}}" class="btn btn-warning">EDITAR</a>
                      <a href="javascript:void(0)" onclick="eliminarCliente('/eliminarAsignatura/{{asignatura.idAsignaturadcp}}');"
                    class="btn btn-danger">
                      Eliminar
                    </a></td>
                  </tr>
                {% endfor %}
              </tbody>
            </table>
            <div class="container-fluid pt-4 px-4">
                <div class="row g-4">
                    <div class="col-sm-12 col-xl-12">
                        <div class="bg-secondary text-center rounded p-4">
                            <div class="d-flex align-items-center justify-content-between mb-4">
                                <h6 class="mb-0">Asignatura y curso</h6>

                            </div>
                            <canvas id="myChart"></canvas>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Script para generar gráfico con Chart.js -->
            <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
            <script>
                // Obtener datos de la tabla para el gráfico
                var table = document.getElementById('tbl');
                var dataLabels = [];
                var dataValues = [];

                for (var i = 1; i < table.rows.length; i++) {
                    var row = table.rows[i];
                    dataLabels.push(row.cells[9].innerText); // Asume que el nombre del curso está en la décima columna
                    dataValues.push(1); // Contar cada asignatura como 1
                }

                // Crear un objeto para contar la cantidad de asignaturas por curso
                var countByCourse = {};
                for (var i = 0; i < dataLabels.length; i++) {
                    var course = dataLabels[i];
                    countByCourse[course] = (countByCourse[course] || 0) + dataValues[i];
                }

                // Datos dinámicos para el gráfico
                var data = {
                    labels: Object.keys(countByCourse),
                    datasets: [{
                        label: 'Cantidad de Asignaturas por Curso',
                        data: Object.values(countByCourse),
                        backgroundColor: 'rgba(75, 192, 192, 0.2)',
                        borderColor: 'rgba(75, 192, 192, 1)',
                        borderWidth: 1
                    }]
                };

                // Configuración del gráfico
                var options = {
                    scales: {
                        y: {
                            beginAtZero: true,
                            stepSize: 1 // Configurar el paso para mostrar solo números enteros
                        }
                    }
                };

                // Crear gráfico en el canvas con id 'myChart'
                var ctx = document.getElementById('myChart').getContext('2d');
                var myChart = new Chart(ctx, {
                    type: 'bar',
                    data: data,
                    options: options
                });
            </script>


          <!-- Modal -->
          <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header bg-secondary">
                  <h3 class="h4 text-black mb-4">Registro de Asignatura</h3>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body bg-secondary">
                  <!-- curso_form.html -->
                  <form  method="post" action="{% url 'crearAsignatura' %}"
                  enctype="multipart/form-data" id="frm_asignatura" class="needs-validation">
                      {% csrf_token %}
                      <div class="mb-3">
                        <select class="form-control selectpicker" data-live-search="true"
                        name="curso" id="curso"  aria-label="Floating label select example">
                        <option value="" disabled selected>-- Seleccione el curso --</option>
                        {% for curso in cursos %}
                            <option value="{{ curso.idCursodcp }}">{{ curso.nivelCursodcp }}</option>
                        {% endfor %}
                    </select>

                      </div>
                        <label for="nombreAsignatura">Nombre de la Asignatura:</label>
                        <input class="form-control" type="text" id="nombre" name="nombre" >
                        <br>

                        <label for="creditosAsignatura">Créditos de la Asignatura:</label>
                        <input class="form-control" type="number" id="creditos" name="creditos" >
                        <br>

                        <label for="fechaInicio">Fecha de Inicio:</label>
                        <input  class="form-control"type="date" id="fechaInicio" name="fechaInicio" >
                        <br>

                        <label for="fechaFinal">Fecha de Finalización:</label>
                        <input class="form-control" type="date" id="fechaFinal" name="fechaFinal" >
                        <br>

                        <label for="profesor">Profesor:</label>
                        <input class="form-control" type="text" id="profesor" name="profesor" >
                        <br>

                        <label for="silabo">Silabo (opcional):</label>
                        <input  class="form-control"type="file" id="silabo" name="silabo">
                        <br>
                        <label for="semestre">Semestre (opcional):</label>
                        <input  class="form-control"type="text" id="semestre" name="semestre" required>
                        <br>
                        <label for="descripcion">Descripción (opcional):</label>
                        <textarea  class="form-control"id="descripcion" name="descripcion"></textarea>
                        <br>
                        <input type="submit" value="Guardar">
                      </form>

                      <!-- Ahora puedes agregar tu script de validación -->
                      <script>
                        $.validator.addMethod("nombreApellido", function(value, element) {
                            return this.optional(element) || /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+\s[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+$/.test(value);
                        }, "Por favor, introduce un nombre y un apellido con un espacio en el medio.");
                        $.validator.addMethod("nomAsignatura", function(value, element) {
                          return this.optional(element) || /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ\s]+$/.test(value);
                        }, "Por favor, introdusca solo letras en asignatura.");

                        // Inicializa el formulario para validación
                        $("#frm_asignatura").validate({
                        rules: {
                          curso: {
                            required: true
                          },
                          nombre: {
                            required: true,
                            nomAsignatura:true
                          },
                          creditos: {
                            required: true,
                            digits: true,
                            range: [1, 3]
                          },
                          fechaInicio: {
                            required: true,
                            date: true
                          },
                          fechaFinal: {
                            required: true,
                            date: true,
                            greaterThan: "#fechaInicio" // Custom rule for date comparison
                          },
                          profesor: {
                            required: true,
                            // lettersonly: true,
                            nombreApellido:true
                          },
                          silabo: {
                            required: true,
                            extension: "pdf|doc|docx"
                          },
                          semestre: {
                            required:true,
                            lettersonly: true,
                            noSpace: true
                          },
                          descripcion: {
                            required: true
                          }
                        },
                        messages: {
                          curso: "Por favor, seleccione un curso",
                          nombre: "Por favor, introduzca el nombre de la asignatura",
                          creditos: {
                            required: "Por favor, introduzca el número de créditos",
                            digits: "Por favor, introduzca solo números enteros",
                            range: "Por favor, ingrese un número entre 1 y 3"
                          },
                          fechaInicio: {
                            required: "Por favor, seleccione la fecha de inicio",
                            date: "Por favor, ingrese una fecha válida"
                          },
                          fechaFinal: {
                            required: "Por favor, seleccione la fecha de finalización",
                            date: "Por favor, ingrese una fecha válida",
                            greaterThan: "La fecha de finalización debe ser posterior a la fecha de inicio"
                          },
                          profesor: {
                            required: "Por favor, introduzca el nombre del profesor",
                            lettersonly: "Por favor, ingrese solo letras en el nombre del profesor"
                          },
                          silabo: {
                            required: "Por favor, seleccione un archivo PDF, DOC o DOCX",
                            extension: "Por favor, seleccione un archivo con una extensión válida (pdf, doc, docx)"
                          },
                          semestre: {
                            required: "Por favor, ingrese un semestre",
                            lettersonly: "Por favor, ingrese solo letras en el semestre",
                            noSpace: "No se permiten espacios en el semestre"
                          },
                          descripcion: "Por favor, ingrese una descripción"
                        },
                        // errorElement: "span",

                        submitHandler: function (form) {
                          form.submit();
                        },
                        // errorPlacement: function (error, element) {
                        //   // Ajusta la colocación del mensaje de error
                        //   error.addClass("invalid-feedback");
                        //   element.closest(".mb-3").append(error);
                        // },
                        highlight: function (element, errorClass, validClass) {
                          // Añade clases de Bootstrap para resaltar errores
                          $(element).addClass("is-invalid").removeClass("is-valid");
                        },
                        unhighlight: function (element, errorClass, validClass) {
                          // Añade clases de Bootstrap cuando no hay errores
                          $(element).removeClass("is-invalid").addClass("is-valid");
                        },
                        });

                        // Custom validation rule for date comparison
                        $.validator.addMethod("greaterThan", function (value, element, param) {
                        var startDate = $(param).val();
                        return new Date(value) > new Date(startDate);
                        }, "La fecha de finalización debe ser posterior a la fecha de inicio");

                        // Custom validation rule for no spaces
                        $.validator.addMethod("noSpace", function (value, element) {
                        return value.indexOf(" ") === -1;
                        }, "No se permiten espacios");

                      </script>

                </div>
                <div class="modal-footer">
                </div>
              </div>
            </div>
          </div>
          <script type="text/javascript">
                   //let table = new DataTable('#tbl_clientes');
                    $('#tbl').DataTable( {
                      dom: 'Bfrtip',
                      buttons: [
                          {
                              extend: 'pdfHtml5',
                              messageTop: 'PDF created by PDFMake with Buttons for DataTables.'
                          },
                          'print',
                          'csv'
                      ]
                    } );
                  </script>
{% endblock %}
